function chuonthisInitPrefs(branch) {
  return Components.classes["@mozilla.org/preferences-service;1"].getService(Components.interfaces.nsIPrefService).getBranch(branch);
}

function chuonthisGetPrefString(prefs, prefname) {
  try {
    return prefs.getComplexValue(prefname, Components.interfaces.nsISupportsString).data;
  } catch (ex) {
    return "";
  }
}

function chuonthisSetPrefString(prefs, prefname, prefvalue) {
  var str = Components.classes["@mozilla.org/supports-string;1"].createInstance(Components.interfaces.nsISupportsString);
  str.data = prefvalue;
  prefs.setComplexValue(prefname, Components.interfaces.nsISupportsString, str);
}

function chuonthisGetPrefBool(prefs, prefname, defvalue) {
  try {
    return prefs.getBoolPref(prefname);
  } catch (ex) {
    return defvalue;
  }
}